' Attiny-Platine      Antonius Ewald, 08/2014
' Umsetzung Elv Sm8 - > Markiese ; Verriegelung
'----------------------------------------------------------------------------

$regfile = "attiny2313.dat"                                 'Attiny2313
$crystal = 1000000                                          '1 MHz  Interner Takt

' http://avrhelp.mcselec.com/index.html?config_timer1.htm
'
'**********************************************************
'******************* Deklarationen ************************
' 0 = Eingang
' 1 = Ausgang
Ddrb = &B00001100                                           'Port B Bit3 + 4 Ausgang
Ddrd = &B00110011                                           'Port D Bit 0+1 Ausgang Rest Eingang
Portd = &B00001100                                          'Eingnge auf high legen
Portb = &B00000000
' --- definiere Variable
Dim T_voreinstellung As Word
Dim Sekunde As Byte
Dim Sekunde_1 As Byte
Dim Haltezeit As Byte
Dim Flr_in As Byte
Dim Ser_nr As String * 15
' --- Definiere Voreinstellungen ---
T_voreinstellung = 49911                                    ' Prescaler 64 und T-Reg = 1 Hz
Sekunde = 0                                                 ' Sekunde zu 0
Haltezeit = 50                                              ' Haltezeit Relais 1 / 2
' --- Zuordung der Ports ---
In_7 Alias Pind.2                                           ' Inputs vom Port mitPIN lesen,
In_8 Alias Pind.3                                           ' sonst liest man nur das Latch
Led_1 Alias Portd.0                                         ' Ports der Ausgnge
Led_2 Alias Portd.1
Led_3 Alias Portd.4
Led_4 Alias Portd.5
Rel_7 Alias Portb.2
Rel_8 Alias Portb.3
' --- Flagregister, Flags definieren ---
Fl_timer Alias Flr_in.0
Fl_in7 Alias Flr_in.2
Fl_in8 Alias Flr_in.3
'
'****************** Initialisierung ***********************
'
Reset Rel_7                                                 ' Relais ausschalten
Reset Rel_8
' --- Interrupt fr Timer vorbereiten --
Enable Interrupts                                           ' Interrupts zulassen
Config Timer1 = Timer , Prescale = 64
Enable Ovf1 , Timer1                                        'Int bei Timer berlauf
On Ovf1 Timer_isr                                           'Sprungvector fr Interrupt
Enable Timer1                                               'Timer aktivieren
Timer1 = T_voreinstellung
Start Timer1                                                ' Voreinstellung -> 65536 dann Int OVL
'
' ****************** bernehme Eingangszustand in Flags
'
If In_7 = 1 Then
   Set Fl_in7                                               ' LED 1 / 2 zeigt den Zustand der Flags
   Set Led_1
Else
   Reset Fl_in7
   Reset Led_1
End If
If In_8 = 1 Then
   Set Fl_in8
   Set Led_2
Else
   Reset Fl_in8
   Reset Led_2
End If
'
'******************** Hauptprogramm ***********************
' Prfe zunchst, ob sich der Eingangszustand gendert hat
'**********************************************************
Main:
If In_7 = Fl_in7 Then                                       'der Eingang ist unverndert,
   Goto In7_no_change                                       'nichts tun
Else
   Toggle Led_1                                             'sonst Eingang ist gendert, Teste,
   Goto Test_relais:                                        'ob ein Relais abgeschaltet werden muss
End If

In7_no_change:
If In_8 = Fl_in8 Then                                       'das gleiche fr den 2. Input
   Goto In8_no_change
   Else
   Toggle Led_2
   Goto Test_relais
End If
'
In8_no_change:
Test_timer_active:
If Fl_timer = 1 Then                                        'wenn Timer luft
      If Sekunde => Haltezeit Then                          'Teste ob Haltezeit zuende
         Stop Timer1                                        'dann stoppe Timer
         Sekunde = 0                                        'Sekunden Register lschen
         Reset Fl_timer                                     'Flag fr Timer lschen
         Reset Rel_7                                        'Reset beide Relais
         Reset Rel_8
         Reset Led_4
      End If                                                'sonst nichts unternehmen
End If
Goto Main:                                                  'und wieder von Vorne
'------------------------------------------------------
' Teste, ob ein Relais angezogen,
' wenn, dann ausschalten
' und FLR_IN aktualisieren
'------------------------------------------------------
Test_relais:
' Ist Relais 7 oder 8 angezogen, schalte aus
' und egalisiere die FLR's
If Rel_7 = 1 Then
   Goto Reset_relais
End If
If Rel_8 = 1 Then
   Goto Reset_relais
End If
'
Goto Set_relais
'
Reset_relais:
   Reset Rel_7                                              'Relais aus
   Reset Rel_8                                              'Relais aus
   Fl_in7 = In_7                                            'bernehme FLR
   Fl_in8 = In_8
   Reset Fl_timer
   Reset Led_4                                              'Loesche indikator
   Stop Timer1
   Reset Led_3                                              'Stop Timer
   Sekunde = 0                                              'Lsche Register Sekunde
Goto Main                                                   'und raus
'
' Prfe, welchel Relais gestzt werden muss
Set_relais:
If Fl_in7 <> In_7 Then                                      'Input <> Flagregister
   Set Rel_7                                                'Setzte Relais 7
   Fl_in7 = In_7                                            'Gleich FLR an
   Timer1 = T_voreinstellung                                'Timervoreinstellungen setzen
   Start Timer1                                             'Timer luft                                             'Starte Timer
   Set Fl_timer
   Set Led_4
   Sekunde = 0                                              'Setzte Sekunde zu 0
'   Goto Main                                                'und raus
End If

If Fl_in8 <> In_8 Then                                      'Das gleiche fr Relais 8
   Set Rel_8
   Fl_in8 = In_8
   Timer1 = T_voreinstellung
   Start Timer1
   Set Fl_timer
   Set Led_4
   Sekunde = 0
   Goto Main
End If
Goto Main:
'------------------------------------------------------
'Interrupt, wenn Timer 1 = OVL
' Timer ist vorbesetzt mit T_reg = 34286
'------------------------------------------------------
Timer_isr:
Timer1 = T_voreinstellung                                   'Timer Voreinstellung erneuern
Incr Sekunde                                                ' +1
Toggle Led_3                                                ' Indikator
Return                                                      'Und weiter im Hauptprogramm
'**********************************************************
Ser_nr = "Antonius Ewald"

